100 REMark **********************************************
110 REMark                ADVENTURE SHELL
120 REMark **********************************************
130 REMark                by Tim Hartnell
140 REMark             Interface publications
150 REMark **********************************************
160 REMark       Converted to QL BASIC and enhanced
170 REMark             by David Denham, 2017
180 REMark **********************************************
190 REMark v1.0 (QL)
200 :
210 REMark **********************************************
220 REMark *            SET DISPLAY WINDOWS             *
230 REMark **********************************************
240 WINDOW #0,512,256,0,0
250 BORDER #0,1,255
260 PAPER #0,0 : INK #0,7 : CLS #0
270 :
280 RANDOMISE  : REMark ** BEST RANDOM NUMBERS WE CAN GET
290 :
300 REMark **********************************************
310 REMark * SET VARIABLES, MAP, MONSTERS, TREASURE ETC *
320 REMark **********************************************
330 INITIALISE : REMark ** SET VARIABLES ETC
340 :
350 REMark **********************************************
360 REMark * SHOW GAME TITLE AND ANY INTRODUCTORY TEXT  *
370 REMark **********************************************
380 UNDER #0,1 : PRINT #0,TITLE$ : UNDER #0,0
390 SHOW_INTRODUCTORY_TEXT
400 :
410 REPeat GAME
420   REMark *********************************************
430   REMark * HAVE WE REACHED THE HIGHEST ROOM NUMBER?  *
440   REMark * IF SO, REPORT SUCCESSFUL COMPLETION       *
450   REMark *********************************************
460   IF ROOM = NO_OF_ROOMS THEN
470     QUIT_FLAG = 1 : REMark SUCCESFUL COMPLETION FLAG
480     EXIT GAME
490   END IF
500   :
510   REMark ********************************************
520   REMark *      DISPLAY THE ROOM DESCRIPTIONS       *
530   REMark ********************************************
540   DISPLAY_ROOM_DESCRIPTION
550   :
560   REMark ********************************************
570   REMark * NEXT LINE ACTIVATED IF OBJECT(S) IN ROOM *
580   REMark ********************************************
590   IF MAP(ROOM,5) + MAP(ROOM,6) + MAP(ROOM,7) > 0 THEN DESCRIBE_OBJECTS_IN_ROOM
600   :
610   REMark ********************************************
620   REMark * NEXT LINES ACTIVATED IF MONSTER IN ROOM  *
630   REMark *  THE MONSTER MAY ATTACK YOU AT RANDOM!   *
640   REMark ********************************************
650   IF MAP(ROOM,8) > 0 THEN
660     REMark ** >0 means there IS a monster in the room
670     RAN = RND(1 TO 3)
680     SELect ON RAN
690       =1 : PRINT #0,"** LOOK OUT!";
700       =2 : PRINT #0,"** BE CAREFUL!";
710       =3 : PRINT #0,"** OH OH!";
720     END SELect
730     PRINT #0," There is a";
740     IF MONSTER$(MAP(ROOM,8),1) INSTR "AEIOU" THEN PRINT #0,"n";
750     PRINT #0," ";MONSTER$(MAP(ROOM,8));" here!"
760     IF RND > .7 THEN
770       REMark ** 30% chance the monster might attack you in the room
780       PRINT #0,"The ";MONSTER$(MAP(ROOM,8));
790       RAN = RND(1 TO 3)
800       SELect ON RAN
810         =1 : PRINT #0," goes for you!"
820         =2 : PRINT #0," attacks!"
830         =3 : PRINT #0," pounces on you!"
840       END SELect
850       KW = 1
860       FIGHT_ROUTINE
870       NEXT GAME
880     ELSE
890       REMark ** MONSTER DOES NOT ATTACK,SO RANDOMLY
900       REMark ** PRINT A MESSAGE TO THAT EFFECT.
910       IF RND > .3 THEN
920         IF RND > .5 THEN PRINT #0,"Fortunately, t"; : ELSE PRINT #0,"T";
930         PRINT #0,"he ";MONSTER$(MAP(ROOM,8));" ";
940         RAN = RND(1 TO 3)
950         SELect ON RAN
960           =1 : PRINT #0,"does not notice you."
970           =2 : PRINT #0,"ignores you."
980           =3 : PRINT #0,"is asleep."
990         END SELect
1000       END IF
1010     END IF
1020   ELSE
1030     IF MAP(ROOM,8) < 0 THEN
1040       REMark ** MONSTER REAPPEARS AFTER BRIEF NAP FOLLOWING FIGHT
1050       IF RND > .5 THEN MAP(ROOM,8) = ABS(ROOM,8)
1060     END IF
1070   END IF
1080   :
1090   REMark ********************************************
1100   REMark *     NEXT LINES DECREMENT ATTRIBUTES      *
1110   REMark *     AND REPORT ATTRIBUTES TO PLAYER      *
1120   REMark ********************************************
1130   IF RND > .94 THEN H_STRE = H_STRE - 1 : IF H_STRE < 0 THEN H_STRE = 0 : REMark STRENGTH
1140   IF RND > .94 THEN H_CHAR = H_CHAR - 1 : IF H_CHAR < 0 THEN H_CHAR = 0 : REMark CHARISMA
1150   IF RND > .94 THEN H_DEXT = H_DEXT - 1 : IF H_DEXT < 0 THEN H_DEXT = 0 : REMark DEXTERITY
1160   IF RND > .94 THEN H_INTE = H_INTE - 1 : IF H_INTE < 0 THEN H_INTE = 0 : REMark INTELLIGENCE
1170   IF RND > .94 THEN H_WISD = H_WISD - 1 : IF H_WISD < 0 THEN H_WISD = 0 : REMark WISDOM
1180   IF RND > .94 THEN H_CONS = H_CONS - 1 : IF H_CONS < 0 THEN H_CONS = 0 : REMark CONSTITUTION
1190   :
1200   PRINT #0,"Your attributes are : Strength    : ";H_STRE TO 40;"Charisma: ";H_CHAR TO 54;"Dexterity   : ";H_DEXT
1210   PRINT #0,"                      Intelligence: ";H_INTE TO 40;"Wisdom  : ";H_WISD TO 54;"Constitution: ";H_CONS
1220   :
1230   REMark ********************************************
1240   REMark *  NEXT LINE CHECKS IF ANY ATTRIBUTE IS 0  *
1250   REMark *   IN WHICH CASE YOU HAVE LOST THE GAME   *
1260   REMark ********************************************
1270   IF H_STRE * H_CHAR * H_DEXT * H_CONS * H_INTE * H_WISD = 0 THEN
1280     REMark ** YOU ARE EXHAUSTED,SO GAME ENDS
1290     QUIT_FLAG = 2 : REMark QUIT FLAG - 2=EXHAUSTED
1300     EXIT GAME
1310   END IF
1320   :
1330   REMark ********************************************
1340   REMark * SHOW LIST OFITEMS CARRIED PLUS THE VALUE *
1350   REMark ********************************************
1360   INVENTORY
1370   :
1380   REMark ********************************************
1390   REMark *  PARSER - NEXT LINES ACCEPT PLAYER INPUT *
1400   REMark ********************************************
1410   KW = 0 : REMark ** KEYWORD - EQUALS 1 IF UNDERSTOOD
1420   REPeat ENTER
1430     INPUT #0,\"What do you want to do ? ";USER_INPUT$
1440     USER_INPUT$ = TL$(USER_INPUT$) : REMark STRIP LEFT SPACES
1450     IF USER_INPUT$ <> "" THEN EXIT ENTER
1460     REMark BLANK INPUT
1470     IF RND > .5 THEN PRINT #0,"Huh?" : ELSE PRINT #0,"Eh?" : END IF
1480   END REPeat ENTER
1490   :
1500   SPACE = " " INSTR USER_INPUT$ : REMark BREAK UP BOTH WORDS
1510   IF SPACE = 0 THEN
1520     WORD1$ = USER_INPUT$ : WORD2$ = "" : REMark ONE WORD ONLY
1530   ELSE
1540     WORD1$ = USER_INPUT$(1 TO SPACE-1)                   : REMark FIRST WORD
1550     WORD2$ = TL$(USER_INPUT$(SPACE TO LEN(USER_INPUT$))) : REMark SECOND WORD/PHRASE IF GIVEN
1560   END IF
1570   :
1580   REMark ***********************************************************
1590   REMark *  TEST PARSER BY PRINTING BOTH WORDS IN < > BRACKETS     *
1600   REMark *  REMOVE THE REM STATEMENTS TO TEST PARSER               *
1610   REMark ***********************************************************
1620   REMark PRINT #0,"WORD 1:<";WORD1$;">"
1630   REMark PRINT #0,"WORD 2:<";WORD2$;">"
1640   REMark ***********************************************************
1650   :
1660   IF WORD2$ = "" THEN
1670     REMark *********************************************************
1680     REMark *    SINGLE WORD COMMANDS SUCH AS "HELP" AND "QUIT"     *
1690     REMark *********************************************************
1700     :
1710     IF WORD1$ == "HELP" THEN
1720       REMark ** HELP COMMAND - amend if you wish to provide HELP
1730       PRINT "You must be joking!"
1740       KW = 1
1750     END IF
1760     :
1770     IF WORD1$ == "QUIT" THEN
1780       REMark ** QUIT COMMAND
1790       KW = 1 : QUIT_FLAG = 4 : REMark QUIT MODE FLAG
1800       EXIT GAME : REMark PRINT CLOSING SUMMARY
1810     END IF
1820     :
1830     IF WORD1$ == "VOCAB" OR WORD1$ == "VOCABULARY" THEN
1840       REMark ** VOCABULARY COMMAND - EDIT THE LIST IN PROC "VOCABULARY"
1850       KW = 1 : VOCABULARY
1860     END IF
1870     :
1880     IF WORD1$ == "MAP" THEN
1890       REMark ** MAP COMMAND - EDIT THE PROCEDURE "SHOW_MAP" TO SUIT
1900       KW = 1 : SHOW_MAP
1910     END IF
1920     :
1930     REMark *********************************************************
1940     REMark *  ADD ANY FURTHER SINGLE WORD COMMANDS HERE,USING THE  *
1950     REMark *  EXAMPLES ABOVE.                                      *
1960     REMark *********************************************************
1970     :
1980   ELSE
1990     REMark *********************************************************
2000     REMark *  TWO WORD VERB / NOUN COMMANDS ARE INTERPRETED HERE.  *
2010     REMark *********************************************************
2020     :
2030     REMark *********************************************************
2040     REMark *  NEXT LINES 'UNDERSTAND' USER INPUT.                  *
2050     REMark *  IF YOU PREFER,  CHANGE TO JUST TESTING FIRST 2 OR 3  *
2060     REMark *  LETTERS OF A WORD TO ALLOW ABBREVIATION OF COMMANDS  *
2070     REMark *  E.G. KI INSTEAD OF 'KILL', G INSTEAD OF 'GO'         *
2080     REMark *********************************************************
2090     :
2100     REMark ** NEXT LINE ACCEPTS 'KILL' OR 'FIGHT' OR 'ATTACK' OR 'SLAY'
2110     IF WORD1$ == "KILL" OR WORD1$ == "FIGHT" OR WORD1$ == "ATTACK" OR WORD1$ == "SLAY" THEN
2120       KW = 1 : FIGHT_ROUTINE
2130     END IF
2140     :
2150     REMark ** NEXT LINE ACCEPTS 'RUN' OR 'GO' OR 'MOVE'
2160     IF WORD1$ == "GO" OR WORD1$ == "MOVE" OR WORD1$ == "RUN" OR WORD1$ == "WALK" THEN
2170       KW = 1 : MOVEMENT_ROUTINE
2180     END IF
2190     :
2200     REMark ** NEXT LINE ACCEPTS 'GET' OR 'TAKE' OR 'LIFT' OR 'GRAB'
2210     IF WORD1$ == "GET" OR WORD1$ == "TAKE" OR WORD1$ == "LIFT" OR WORD1$ == "GRAB" THEN
2220       KW = 1 : GET_OBJECTS_ROUTINE
2230     END IF
2240     :
2250     REMark ** NEXT LINE ACCEPTS 'DROP' 'PUT' OR 'LEAVE'
2260     IF WORD1$ == "DROP" OR WORD1$ == "PUT" OR WORD1$ == "LEAVE" THEN
2270       KW = 1 : DROP_OBJECTS_ROUTINE
2280     END IF
2290     :
2300     REMark ** NEXT LINE ACCEPTS 'UNLOCK' OR 'OPEN'
2310     REMark ** IF A DIRECTION GIVEN, UNLOCK THAT EXIT, BUT UNLOCK IN
2320     REMark ** BOTH DIRECTIONS
2330     IF WORD1$ == "UNLOCK" OR WORD1$ == "OPEN" THEN
2340       KW = 1 : UNLOCK_EXIT
2350     END IF
2360     :
2370     REMark *********************************************************
2380     REMark *   ADD ANY FURTHER TWO WORD COMMANDS HERE, USING THE   *
2390     REMark *   EXAMPLES ABOVE.                                     *
2400     REMark *********************************************************
2410     :
2420   END IF
2430   :
2440   REMark ***********************************************************
2450   REMark *  KW=1 MEANS KEYWORD UNDERSTOOD, 0 MEANS NOT UNDERSTOOD  *
2460   REMark ***********************************************************
2470   IF KW = 0 THEN
2480     REMark *****************************************
2490     REMark *  CHOOSE "I DON'T UNDERSTAND" MESSAGE  *
2500     REMark *****************************************
2510     RAN = RND(1 TO 3)
2520     SELect ON RAN
2530       =1 : PRINT #0,"It would not be wise to ";USER_INPUT$
2540       =2 : PRINT #0,"Only a fool would try to ";USER_INPUT$
2550       =3 : PRINT #0,"I don't understand ";USER_INPUT$
2560     END SELect
2570   END IF
2580   :
2590   PAUSE 50
2600   :
2610 END REPeat GAME
2620 :
2630 END_OF_GAME
2640 :
2650 REMark ********************************************
2660 REMark *  RESET BASIC WINDOWS AFTER RUNNING GAME  *
2670 REMark ********************************************
2680 REMark IF NOT COMPILED THEN WTV 4 : REMark OR WMON 4 IF YOU PREFER
2690 STOP
2700 :
2710 DEFine PROCedure VOCABULARY
2720   REMark ********************************************
2730   REMark *  SHOW LIST OF WORDS PROGRAM UNDERSTANDS  *
2740   REMark ********************************************
2750   PRINT #0,"List of commands:"
2760   PRINT #0,"HELP QUIT VOCABULARY KILL FIGHT ATTACK SLAY GO MOVE MAP"
2770   PRINT #0,"RUN WALK GET TAKE LIFT GRAB DROP PUT LEAVE UNLOCK OPEN."
2780 END DEFine VOCABULARY
2790 :
2800 DEFine PROCedure MOVEMENT_ROUTINE
2810   LOCal EXIT_NO
2820   REMark ********************************************
2830   REMark * MOVEMENT ROUTINE - CHECK THE ROOM EXITS. *
2840   REMark ********************************************
2850   WORD2$ = LEFT$(WORD2$,1) : EXIT_NO = WORD2$ INSTR "nsew"
2860   IF EXIT_NO = 0 THEN PRINT #0,"Go where?" : RETurn
2870   IF MAP(ROOM,EXIT_NO) <= 0 THEN
2880     IF MAP(ROOM,EXIT_NO) < 0 THEN
2890       PRINT #0,"That exit is locked."
2900     ELSE
2910       PRINT #0,"You can't go that way."
2920     END IF
2930     RETurn
2940   END IF
2950   :
2960   REMark ** EXIT IN SPECIFIED DIRECTION LEADS TO WHICH
2970   REMark ** ROOM NUMBER? SET 'ROOM' TO NEW ROOM NUMBER
2980   ROOM = MAP(ROOM,EXIT_NO)
2990 END DEFine MOVEMENT_ROUTINE
3000 :
3010 DEFine PROCedure UNLOCK_EXIT
3020   LOCal EXIT_NO, OBJ_NO, X, EXIT_TO
3030   REMark ********************************************
3040   REMark * IF CARRYING THE KEY (OBJECT 1),  AND THE *
3050   REMark * SPECIFIED EXIT IS A -VE NUMBER,UNLOCK IT *
3060   REMark * BY TURNING THE EXIT NUMBER +VE.          *
3070   REMark ********************************************
3080   WORD2$ = LEFT$(WORD2$,1) : EXIT_NO = WORD2$ INSTR 'nsew'
3090   IF EXIT_NO = 0 THEN PRINT #0,"Eh?" : RETurn
3100   REMark ** check if first object (key) being carried
3110   OBJ_NO = 0
3120   FOR X = 1 TO 5
3130     IF CARRIED(X) = 1 THEN OBJ_NO = 1 : EXIT X : REMark ** KEY
3140   END FOR X
3150   IF OBJ_NO <> 1 THEN PRINT #0,"No key!" : RETurn
3160   IF MAP(ROOM,EXIT_NO) = 0 THEN PRINT #0,"No exit that way." : RETurn
3170   IF MAP(ROOM,EXIT_NO) > 0 THEN PRINT #0,"Not locked."       : RETurn
3180   REMark ** EXIT IS LOCKED, SO UNLOCK FROM BOTH SIDES
3190   REMark ** FIRST, THIS SIDE
3200   MAP(ROOM,EXIT_NO) = ABS(MAP(ROOM,EXIT_NO))
3210   REMark ** NOW OTHER SIDE, UNLOCK EXIT IN OPPOSITE DIRECTION
3220   EXIT_TO = MAP(ROOM,EXIT_NO)
3230   IF EXIT_NO = 1 OR EXIT_NO = 3 THEN
3240     MAP(EXIT_TO,EXIT_NO+1) = ABS(MAP(EXIT_TO,EXIT_NO+1))
3250   ELSE
3260     MAP(EXIT_TO,EXIT_NO-1) = ABS(MAP(EXIT_TO,EXIT_NO-1))
3270   END IF
3280 END DEFine UNLOCK_EXIT
3290 :
3300 DEFine PROCedure SHOW_MAP
3310   REMark ********************************************
3320   REMark * PRINT A SIMPLE TEXT MAP-EDIT AS REQUIRED *
3330   REMark * FOR YOUR ROOM PLAN,INCLUDE AS MUCH OR AS *
3340   REMark * LITTLE DETAIL AS YOU WANT TO INCLUDE.    *
3350   REMark * CHANGE COLOURS, FOR EXAMPLE TO HIGHLIGHT *
3360   REMark * ENTRY/EXIT/LOCKED/OBJECTS/MONSTERS ETC.  *
3370   REMark ********************************************
3380   PRINT #0,
3390   PRINT #0,"                   16 <-Exit"
3400   PRINT #0,"                   X  <-Locked Door"
3410   PRINT #0,"       01    02 -- 03"
3420   PRINT #0,"       |     |"
3430   PRINT #0,"       04 -- 05 -- 06"
3440   PRINT #0,"       |"
3450   PRINT #0,"       08    09 -- 10   07"
3460   PRINT #0,"       |     |          |"
3470   PRINT #0,"       11 -- 12 ------- 13"
3480   PRINT #0,"       |"
3490   PRINT #0," Key-> 14 -- 15"
3500 END DEFine SHOW_MAP
3510 :
3520 DEFine PROCedure INVENTORY
3530   LOCal COUNTER,DONE
3540   REMark ********************************************
3550   REMark * THE NEXT LINES CHECK TO SEE IF PLAYER IS *
3560   REMark * CARRYING ANYTHING AND THEN PRINT A LIST  *
3570   REMark ********************************************
3580   TOTAL = 0
3590   FOR COUNTER = 1 TO 5
3600     IF CARRIED(COUNTER) <> 0 THEN TOTAL = TOTAL + 1
3610   END FOR COUNTER
3620   :
3630   IF TOTAL > 0 THEN
3640     CASH = 0
3650     PRINT #0,\"You are carrying:";
3660     DONE = 0
3670     FOR COUNTER = 1 TO 5
3680       IF CARRIED(COUNTER) <> 0 THEN
3690         PRINT #0, OBJECT$(CARRIED(COUNTER));
3700         CASH = CASH + VALUE(CARRIED(COUNTER))
3710         DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
3720       END IF
3730     NEXT COUNTER
3740       PRINT #0,
3750     END FOR COUNTER
3760     IF CASH > 0 THEN
3770       PRINT #0,TO 8;"Total value - ";CURRENCY$;STR$(CASH)
3780     END IF
3790   END IF
3800 END DEFine INVENTORY
3810 :
3820 DEFine PROCedure GET_OBJECTS_ROUTINE
3830   LOCal FLAG, COUNTER, OBJ_NO
3840   REMark ******************************************************
3850   REMark * GET OBJECTS ROUTINE - PICK UP OBJECT IF PRESENT    *
3860   REMark * AND YOU ARE NOT ALREADY CARRYING MAXIMUM NUMBER    *
3870   REMark * OF OBJECTS                                         *
3880   REMark ******************************************************
3890   REMark ** CHECK IN CASE ALREADY CARRYING MAXIMUM NUMBER OF OBJECTS (5)
3900   FLAG = 0 : REMark COUNT OF NUMBER OF OBJECTS BEING CARRIED
3910   FOR COUNTER = 1 TO 5
3920     IF CARRIED(COUNTER) <> 0 THEN FLAG = FLAG + 1
3930   NEXT COUNTER
3940   IF FLAG = 5 THEN PRINT #0,"You are already carrying five objects." : RETurn
3950   :
3960   REMark ******************************************************
3970   REMark *  CHECK IF ANYTHING IN ROOM WHICH CAN BE PICKED UP  *
3980   REMark ******************************************************
3990   IF (MAP(ROOM,5)>0)+(MAP(ROOM,6)>0)+(MAP(ROOM,7)>0) = 0 THEN
4000     REMark ** NOTHING IN THIS ROOM TO BE PICKED UP
4010     PRINT #0,"I see nothing to pick up." : RETurn
4020   END IF
4030   :
4040   REMark ******************************************************
4050   REMark *  NOW PICK IT UP (C$ IS NAME OF OBJECT TO PICK UP)  *
4060   REMark *  ONLY ONE OBJECT CAN BE PICKED UP AT A TIME EVEN   *
4070   REMark *  IF THERE IS MORE THAN ONE WITH THE SAME NAME!     *
4080   REMark ******************************************************
4090   IF WORD2$ == OBJECT$(MAP(ROOM,5)) AND MAP(ROOM,5) > 0 THEN
4100     OBJ_NO = MAP(ROOM,5) : MAP(ROOM,5) = 0 : REMark FIRST OBJECT
4110   ELSE
4120     IF WORD2$ == OBJECT$(MAP(ROOM,6)) AND MAP(ROOM,6) > 0 THEN
4130       OBJ_NO = MAP(ROOM,6) : MAP(ROOM,6) = 0 : REMark SECOND OBJECT
4140     ELSE
4150       IF WORD2$ == OBJECT$(MAP(ROOM,7)) AND MAP(ROOM,7) > 0 THEN
4160         OBJ_NO = MAP(ROOM,7) : MAP(ROOM,7) = 0 : REMark THIRD OBJECT
4170       ELSE
4180         PRINT #0,WORD2$;" is not here." : RETurn
4190       END IF
4200     END IF
4210   END IF
4220   :
4230   REMark ** FIND AN EMPTY SPACE IN PICKED-UP OBJECTS LIST
4240   FOR COUNTER = 1 TO 5
4250     IF CARRIED(COUNTER) = 0 THEN
4260       CARRIED(COUNTER) = OBJ_NO : EXIT COUNTER : REMark INSERT IN FIRST FREE SLOT IN LIST
4270     END IF
4280   END FOR COUNTER
4290   PRINT #0,TO 3;">-> You now have the ";OBJECT$(OBJ_NO)
4300 END DEFine GET_OBJECTS_ROUTINE
4310 :
4320 DEFine PROCedure DROP_OBJECTS_ROUTINE
4330   LOCal FLAG, COUNTER, OBJ_NO
4340   REMark ******************************************************
4350   REMark * DROP OBJECT ROUTINE - FIRST COUNT HOW MANY BEING   *
4360   REMark * CARRIED AT THE MOMENT (0 = NONE, 1 = AT LEAST ONE  *
4370   REMark ******************************************************
4380   FLAG = 0
4390   FOR COUNTER = 1 TO 5
4400     IF CARRIED(COUNTER) <> 0 THEN
4410       FLAG = 1 : EXIT COUNTER : REMark SOMETHING BEING CARRIED
4420     END IF
4430   END FOR COUNTER
4440   IF FLAG = 0 THEN
4450     REMark ** NOTHING CURRENTLY BEING CARRIED
4460     PRINT #0,"You are not carrying anything."
4470     RETurn
4480   END IF
4490   :
4500   REMark ** IS THE ROOM ALREADY FULL OF OBJECTS?
4510   IF (MAP(ROOM,5)<>0) + (MAP(ROOM,6)<>0) + (MAP(ROOM,7)<>0) = 3 THEN
4520     REMark ** ROOM CAN ONLY HOLD 3 OBJECTS
4530     PRINT #0,"This room already holds its maximum number of objects."
4540     RETurn
4550   END IF
4560   :
4570   REMark ** TRY TO MATCH NAME OF OBJECT TO BE DROPPED WITH ITEM IN LIST OF OBJECTS
4580   OBJECT_NAME$  = "" : REMark OBJECT NAME
4590   OBJ_NO        = 0  : REMark OBJECT NUMBER
4600   FOR COUNTER = 1 TO NO_OF_OBJECTS
4610     IF OBJECT$(COUNTER) == WORD2$ THEN
4620       OBJECT_NAME$ = OBJECT$(COUNTER) : OBJ_NO = COUNTER : EXIT COUNTER : REMark NAME MATCHED
4630     END IF
4640   END FOR COUNTER
4650   IF OBJECT_NAME$ = "" THEN
4660     REMark ** THAT OBJECT NOT CURRENTLY BEING CARRIED
4670     PRINT #0,"How can you when you're not holding it."
4680     RETurn
4690   END IF
4700   :
4710   FOR COUNTER = 1 TO 5
4720     IF CARRIED(COUNTER) = OBJ_NO THEN CARRIED(COUNTER) = 0 : REMark RESET CARRIED ITEM NUMBER
4730   END FOR COUNTER
4740   :
4750   REMark ** ADD TO AN UNUSED ROOM OBJECT NUMBER
4760   IF MAP(ROOM,5) = 0 THEN
4770     MAP(ROOM,5) = OBJ_NO : REMark ROOM OBJECT 1
4780   ELSE
4790     IF MAP(ROOM,6) = 0 THEN
4800       MAP(ROOM,6) = OBJ_NO : REMark ROOM OBJECT 2
4810     ELSE
4820       IF MAP(ROOM,7) = 0 THEN MAP(ROOM,7) = OBJ_NO : REMark ROOM OBJECT 3
4830     END IF
4840   END IF
4850   PRINT #0,"You have dropped the ";OBJECT_NAME$;"."
4860 END DEFine DROP_OBJECTS_ROUTINE
4870 :
4880 DEFine PROCedure FIGHT_ROUTINE
4890   REMark *****************************************************
4900   REMark *  FIGHT ROUTINE - NEXT LINES CHECK IF A MONSTER    *
4910   REMark *  IS ACTUALLY PRESENT TO FIGHT OR NOT              *
4920   REMark *****************************************************
4930   IF MAP(ROOM,8) = 0 THEN
4940     REMark ** 0 MEANS NO MONSTER PRESENT, CHOOSE RANDOM MESSAGE
4950     RAN = RND(1 TO 3)
4960     SELect ON RAN
4970       =1 : PRINT #0,"There is nothing to fight here."
4980       =2 : PRINT #0,"You can't fight empty air."
4990       =3 : PRINT #0,"No monster here to fight!"
5000     END SELect
5010     RETurn
5020   END IF
5030   :
5040   REMark ** SET G$ TO NAME OF MONSTER AND CREATE ITS ATTRIBUTES
5050   MONSTER_NAME$ = MONSTER$(MAP(ROOM,8))
5060   M_STRE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5070   M_CHAR = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5080   M_DEXT = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5090   M_INTE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5100   M_WISD = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5110   M_CONS = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5120   REMark ** USE 'AN' BEFORE A VOWEL, 'A' BEFORE A CONSONANT
5130   PRINT #0,"Your opponent is a";
5140   IF MONSTER_NAME$(1) INSTR "AEIOU" THEN PRINT #0,"n";
5150   PRINT #0," ";MONSTER_NAME$;", ";
5160   MONSTER_TALLY = 0 : REMark ** MONSTER'S TALLY
5170   HUMAN_TALLY   = 0 : REMark ** HUMAN'S TALLY
5180   FIGHT_FLAG = M_STRE * RND(1 TO 6) : REMark DANGER LEVEL
5190   PRINT #0,"the ";MONSTER_NAME$;"'s danger level is ";FIGHT_FLAG;"."
5200   PAUSE 25
5210   :
5220   REMark ** CHECK IF CARRYING WEAPONS
5230   REMark ** RUN THROUGH CARRIED ITEMS LIST TO CHECK FOR WEAPONS
5240   FLAG = 0
5250   FOR COUNTER = 1 TO 5
5260     IF CARRIED(COUNTER) <> 0 THEN
5270       IF WEAPON(CARRIED(COUNTER)) <> 0 THEN
5280         FLAG = FLAG + 1
5290         WEAPONS(FLAG) = CARRIED(COUNTER)
5300       END IF
5310     END IF
5320   END FOR COUNTER
5330   REMark ** WEAPONS() HOLDS A LIST OF WEAPONS BEING CARRIED
5340   REMark ** FLAG IS NUMBER OF WEAPONS
5350   SELect ON FLAG
5360     =0 : REMark ** NO WEAPONS CARRIED
5370          PRINT #0,"You must fight the ";MONSTER_NAME$;" with your bare hands."
5380     =1 : REMark ** A SINGLE WEAPON TO FIGHT WITH
5390          PRINT #0,"You must fight with your ";OBJECT$(WEAPONS(1));"."
5400          CHOICE = WEAPONS(1)
5410          FIGHT_FLAG = INT(FIGHT_FLAG*2/(CHOICE+3))
5420     =REMAINDER : REMark ** MORE THAN ONE WEAPON
5430          PRINT #0,"Choose your weapon:"
5440          FOR COUNTER = 1 TO FLAG
5450            PRINT #0,COUNTER;" - ";OBJECT$(WEAPONS(COUNTER))
5460          END FOR COUNTER
5470          REPeat ENTER
5480            INPUT #0,"Enter the number you choose ";CHOICE
5490            IF CHOICE > 0 AND CHOICE <= FLAG AND CHOICE = INT(CHOICE) THEN EXIT ENTER
5500            PRINT #0,"Please enter 1 to ";FLAG;"." : REMark ** OOPS
5510          END REPeat ENTER
5520          PRINT #0,"Right, so you choose to fight with the ";OBJECT$(WEAPONS(CHOICE));"."
5530          CHOICE = WEAPONS(CHOICE)
5540          FIGHT_FLAG = INT(FIGHT_FLAG*2/(CHOICE+3))
5550   END SELect
5560   :
5570   PAUSE 25
5580   :
5590   PRINT #0,"The ";MONSTER_NAME$;" has the following attributes:"
5600   PRINT #0,"   Strength     ";M_STRE TO 20;"  Charisma ";M_CHAR TO 36;"  Dexterity    ";M_DEXT
5610   PRINT #0,"   Intelligence ";M_INTE TO 20;"  Wisdom   ";M_WISD TO 36;"  Constitution ";M_CONS
5620   PRINT #0,"Your attributes are:"
5630   PRINT #0," 1-Strength     ";H_STRE TO 20;"2-Charisma ";H_CHAR TO 36;"3-Dexterity    ";H_DEXT
5640   PRINT #0," 4-Intelligence ";H_INTE TO 20;"5-Wisdom   ";H_WISD TO 36;"6-Constitution ";H_CONS
5650   PRINT #0,"Which attributes will you fight with (2 attributes) ?"
5660   REPeat ENTER
5670     INPUT #0,"Attribute 1:";ATTR1 TO 20;"Attribute 2:";ATTR2
5680     IF ATTR1 > 0 AND ATTR1 < 7 AND ATTR2 > 0 AND ATTR2 < 7 AND ATTR1 <> ATTR2 AND ATTR1 = INT(ATTR1) AND ATTR2 = INT(ATTR2) THEN
5690       EXIT ENTER : REMark ** VALID ENTRY
5700     END IF
5710     REMark ** TRY AGAIN...
5720     PRINT #0,"** Don't fool around with a ";MONSTER_NAME$;" in the room with you!! **"
5730   END REPeat ENTER
5740   IF (ATTR1=1) OR (ATTR2=1) THEN MONSTER_TALLY = MONSTER_TALLY + M_STRE : HUMAN_TALLY = HUMAN_TALLY + H_STRE
5750   IF (ATTR1=2) OR (ATTR2=2) THEN MONSTER_TALLY = MONSTER_TALLY + M_CHAR : HUMAN_TALLY = HUMAN_TALLY + H_CHAR
5760   IF (ATTR1=3) OR (ATTR2=3) THEN MONSTER_TALLY = MONSTER_TALLY + M_DEXT : HUMAN_TALLY = HUMAN_TALLY + H_DEXT
5770   IF (ATTR1=4) OR (ATTR2=4) THEN MONSTER_TALLY = MONSTER_TALLY + M_INTE : HUMAN_TALLY = HUMAN_TALLY + H_INTE
5780   IF (ATTR1=5) OR (ATTR2=5) THEN MONSTER_TALLY = MONSTER_TALLY + M_WISD : HUMAN_TALLY = HUMAN_TALLY + H_WISD
5790   IF (ATTR1=6) OR (ATTR2=6) THEN MONSTER_TALLY = MONSTER_TALLY + M_CONS : HUMAN_TALLY = HUMAN_TALLY + H_CONS
5800   IF HUMAN_TALLY = MONSTER_TALLY THEN
5810     PRINT #0,TO 10;"You are evenly matched."
5820   ELSE
5830     PRINT #0,"It looks like the odds are in favour of ";
5840     IF HUMAN_TALLY > MONSTER_TALLY THEN PRINT #0,"you." : ELSE PRINT #0,"the ";MONSTER_NAME$;"." : END IF
5850   END IF
5860   PAUSE RND(50 TO 100)
5870   :
5880   REMark *****************************************
5890   REMark *  NEXT LINES CONTROL THE FIGHT ITSELF  *
5900   REMark *****************************************
5910   PREV_ACTION = 0
5920   REPeat FIGHT
5930     ACTION = RND(1 TO 10)
5940     IF ACTION = PREV_ACTION THEN NEXT FIGHT : REMark ** MUST NOT BE EQUAL TO PREVIOUS
5950     PREV_ACTION = ACTION
5960     PRINT #0,"The ";MONSTER_NAME$;": ";MONSTER_TALLY;", You: ";HUMAN_TALLY
5970     PAUSE RND(25 TO 100)
5980     SELect ON ACTION
5990       =1 : PRINT #0,"You struck a splendid blow!"                   : MONSTER_TALLY = MONSTER_TALLY - 1
6000       =2 : PRINT #0,"The ";MONSTER_NAME$;" strikes out."            : HUMAN_TALLY = HUMAN_TALLY - 1 : H_CHAR = H_CHAR - 1
6010       =3 : PRINT #0,"You draw the ";MONSTER_NAME$;"'s blood."       : M_STRE = M_STRE - 1
6020       =4 : PRINT #0,"You are wounded!!"                             : H_INTE = H_INTE - 1
6030       =5 : PRINT #0,"The ";MONSTER_NAME$;" is tiring."              : M_DEXT = M_DEXT - 1
6040       =6 : PRINT #0,"You are bleeding..."                           : H_WISD = H_WISD - 1
6050       =7 : PRINT #0,"You wound the ";MONSTER_NAME$;"."              : MONSTER_TALLY = MONSTER_TALLY - 1
6060       =8 : PRINT #0,"Heavy blow by the ";MONSTER_NAME$;"."          : HUMAN_TALLY = HUMAN_TALLY - 1 : H_INTE = H_INTE - 1
6070       =9 : PRINT #0,"You knocked the ";MONSTER_NAME$;" over."       : MONSTER_TALLY = MONSTER_TALLY - 1
6080       =10: PRINT #0,"The ";MONSTER_NAME$;" sees stars momentarily." : MONSTER_TALLY = MONSTER_TALLY - 1
6090     END SELect
6100     :
6110     REMark ** EITHER 1 IN 4 CHANCE OF ENDING THE FIGHT, OR ATTRIBUTES=0
6120     REMark ** MONSTER_TALLY DECREMENTED TWICE AS MUCH AS HUMAN_TALLY DURING FIGHT
6130     REMark ** ALLOWING HUMAN TO WIN SLIGHTLY MORE FIGHTS THAN THE MONSTERS
6140     IF RND <= .25 OR HUMAN_TALLY = 0 OR MONSTER_TALLY = 0 THEN EXIT FIGHT
6150     :
6160     PAUSE RND(50 TO 100) : REMark ** RANDOM SHORT PAUSE BETWEEN BLOWS
6170   END REPeat FIGHT
6180   :
6190   PAUSE RND(50 TO 100)
6200   IF HUMAN_TALLY >= MONSTER_TALLY THEN
6210     REMark ** PLAYER WINS
6220     PRINT #0,"You have slain the ";MONSTER_NAME$
6230     H_STRE = H_STRE + 2 : H_DEXT = H_DEXT + 2 : H_WISD = H_WISD + 2
6240     H_CHAR = H_CHAR + 2 : H_INTE = H_INTE + 2 : H_CONS = H_CONS + 2
6250     MONSTERS_KILLED = MONSTERS_KILLED + 1
6260     MAP(ROOM,8) = 0 : REMark ** RESET MONSTER IN THIS ROOM
6270   ELSE
6280     REMark ** MONSTER WINS
6290     PRINT #0,"The ";MONSTER_NAME$;" got the better of you that time..."
6300     IF (ATTR1=1) OR (ATTR2=1) THEN H_STRE = 4 * INT(H_STRE/5)
6310     IF (ATTR1=2) OR (ATTR2=2) THEN H_CHAR = 3 * INT(H_CHAR/4)
6320     IF (ATTR1=3) OR (ATTR2=3) THEN H_DEXT = 6 * INT(H_DEXT/7)
6330     IF (ATTR1=4) OR (ATTR2=4) THEN H_INTE = 2 * INT(H_INTE/3)
6340     IF (ATTR1=5) OR (ATTR2=5) THEN H_WISD = 5 * INT(H_WISD/6)
6350     IF (ATTR1=6) OR (ATTR2=6) THEN H_CONS = INT(H_CONS/2)
6360     REMark ** MONSTER IS EXHAUSTED AFTER FIGHT, SO HIDES BRIEFLY
6370     REMark ** SO THAT THE FIGHT DOES NOT RESUME IMMEDIATELY
6380     MAP(ROOM,8) = -MAP(ROOM,8) : REMark ** -VE = HIDDEN
6390   END IF
6400   :
6410   MAP(ROOM,8) = 0 : REMark ** RESET MONSTER IN THIS ROOM
6420   :
6430   PAUSE RND(50 TO 100)
6440 END DEFine FIGHT_ROUTINE
6450 :
6460 DEFine PROCedure END_OF_GAME
6470   REMark *************************
6480   REMark *   END OF GAME REPORT  *
6490   REMark *************************
6500   PRINT
6510   SCORE = 0 : REMark ** SCORE
6520   SELect ON QUIT_FLAG
6530     =1 : REMark ** SUCCESSFUL COMPLETION
6540          PRINT #0,\"CONGRATULATIONS... You have completed the ADVENTURE!!!!"
6550          SCORE = 100
6560          PRINT
6570     =2 : REMark ** EXHAUSTION
6580          PRINT #0,\"Unfortunately, you are exhausted... So this adventure must end."
6590     =4 : REMark ** "QUIT" COMMAND
6600          PRINT #0,"I did not imagine you would turn out to be a quitter!"
6610   END SELect
6620   :
6630   REMark ** PRINT CLOSING SUMMARY FOR THIS GAME
6640   SCORE = 99 * (SCORE + 20*CASH + 4*MONSTERS_KILLED + H_STRE + 2*H_CHAR + 3*H_DEXT + 4 + H_INTE + 5*H_WISD + 6*H_CONS)/QUIT_FLAG
6650   :
6660   REMark ** SHOW HOW MANY MONSTERS KILLED
6670   IF MONSTERS_KILLED > 0 THEN
6680     PRINT #0,"You killed ";MONSTERS_KILLED;" monster";
6690     IF MONSTERS_KILLED = 1 THEN PRINT #0,"." : ELSE PRINT #0,"s." : END IF
6700   END IF
6710   :
6720   REMark ** VALUE OF TREASURE FOUND
6730   PRINT #0,"You found ";CURRENCY$;STR$(CASH);" worth of treasure."
6740   :
6750   REMark ** ROUND OFF FINAL SCORE TO WHOLE NUMBER
6760   PRINT #0,"Your score for this adventure is ";INT(SCORE+.5);"."
6770   INPUT #0,\"Thank you for playing ";(TITLE$);". Press ENTER to finish > ";Z$
6780 END DEFine END_OF_GAME
6790 :
6800 DEFine PROCedure DISPLAY_ROOM_DESCRIPTION
6810   REMark *****************************************
6820   REMark *  ADD ROOM DESCRIPTIONS AS REQUIRED    *
6830   REMark *  NO DESCRIPTION REQUIRED FOR THE      *
6840   REMark *  HIGHEST ROOM NUMBER (THE EXIT ROOM)  *
6850   REMark *****************************************
6860   :
6870   PRINT #0,\"You are in ";
6880   :
6890   SELect ON ROOM
6900     =1 : REMark ** ROOM 1
6910          PRINT #0,"Room One";
6920          :
6930     =2 : REMark ** ROOM 2
6940          PRINT #0,"Room Two";
6950          :
6960     =3 : REMark ** ROOM 3
6970          PRINT #0,"Room Three";
6980          :
6990     =4 : REMark ** ROOM 4
7000          PRINT #0,"Room Four";
7010          :
7020     =5 : REMark ** ROOM 5
7030          PRINT #0,"Room Five";
7040          :
7050     =6 : REMark ** ROOM 6
7060          PRINT #0,"Room Six";
7070          :
7080     =7 : REMark ** ROOM 7
7090          PRINT #0,"Room Seven";
7100          :
7110     =8 : REMark ** ROOM 8
7120          PRINT #0,"Room Eight";
7130          :
7140     =9 : REMark ** ROOM 9
7150          PRINT #0,"Room Nine";
7160          :
7170     =10: REMark ** ROOM 10
7180          PRINT #0,"Room Ten";
7190          :
7200     =11: REMark ** ROOM 11
7210          PRINT #0,"Room Eleven";
7220          :
7230     =12: REMark ** ROOM 12
7240          PRINT #0,"Room Twelve";
7250          :
7260     =13: REMark ** ROOM 13
7270          PRINT #0,"Room Thirteen";
7280          :
7290     =14: REMark ** ROOM 14
7300          PRINT #0,"Room Fourteen";
7310          :
7320     =15: REMark ** ROOM 15
7330          PRINT #0,"Room Fifteen";
7340          :
7350   END SELect
7360   :
7370   REMark *****************************************
7380   REMark *  WHERE ARE THE EXITS FROM THIS ROOM?  *
7390   REMark *    FIRST COUNT THE NUMBER OF EXITS    *
7400   REMark *****************************************
7410   EXITS = (MAP(ROOM,1)<>0) + (MAP(ROOM,2)<>0) + (MAP(ROOM,3)<>0) + (MAP(ROOM,4)<>0)
7420   SELect ON EXITS
7430     =0 : REMark ** NO EXITS, SAY NOTHING! (SHOULDN'T HAPPEN)
7440     =1 : REMark ** ONE EXIT ONLY
7450          PRINT #0,", there is an exit ";
7460          FOR X = 1 TO 4
7470            IF MAP(ROOM,X) <> 0 THEN
7480              PRINT #0,DIRECTION$(X);
7490              LOCKED_OR_NOT ROOM,X : REMark PRINT" (locked)" if required
7500              PRINT #0,"."
7510            END IF
7520          END FOR X
7530     =REMAINDER : REMark ** MORE THAN ONE EXIT
7540          PRINT #0,", there are exits ";
7550          DONE = 0 : REMark how many printed so far
7560          IF MAP(ROOM,1) <> 0 THEN
7570            PRINT #0,"North"; : LOCKED_OR_NOT ROOM,1 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
7580          END IF
7590          IF MAP(ROOM,2) <> 0 THEN
7600            PRINT #0,"South"; : LOCKED_OR_NOT ROOM,2 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
7610          END IF
7620          IF MAP(ROOM,3) <> 0 THEN
7630            PRINT #0,"East";  : LOCKED_OR_NOT ROOM,3 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
7640          END IF
7650          IF MAP(ROOM,4) <> 0 THEN
7660            PRINT #0,"West";  : LOCKED_OR_NOT ROOM,4 : DONE = DONE + 1
7670          END IF
7680          PRINT #0,"."
7690   END SELect
7700   :
7710 END DEFine DISPLAY_ROOM_DESCRIPTION
7720 :
7730 DEFine PROCedure LIST_SEPARATOR (ENTRY_NO,LIST_SIZE)
7740   REMark *****************************************
7750   REMark * INSERT "," / "AND" BETWEEN LIST ITEMS *
7760   REMark *****************************************
7770   IF ENTRY_NO < (LIST_SIZE-1) THEN
7780     PRINT #0,", ";
7790   ELSE
7800     IF ENTRY_NO = (LIST_SIZE-1) THEN PRINT #0," and ";
7810   END IF
7820 END DEFine LIST_SEPARATOR
7830 :
7840 DEFine PROCedure LOCKED_OR_NOT(ROOM_NUMBER,EXIT_NUMBER)
7850   REMark ****************************************
7860   REMark * INDICATE IF THIS EXIT LOCKED OR NOT  *
7870   REMark ****************************************
7880   IF MAP(ROOM_NUMBER,EXIT_NUMBER) < 0 THEN PRINT #0," (locked)";
7890 END DEFine LOCKED_OR_NOT
7900 :
7910 DEFine PROCedure SHOW_INTRODUCTORY_TEXT
7920   REMark ****************************************
7930   REMark * PRINT A GENERAL INTRODUCTION FOR THE *
7940   REMark * GAME HERE (OR MAY BE LEFT BLANK)     *
7950   REMark ****************************************
7960   PRINT #0,"This is a skeleton BASIC program for writing your own adventure games."
7970 END DEFine SHOW_INTRODUCTORY_TEXT
7980 :
7990 DEFine PROCedure DESCRIBE_OBJECTS_IN_ROOM
8000   LOCal TOTAL,DONE
8010   REMark ****************************************
8020   REMark *  DESCRIBE OBJECTS SEEN IN THIS ROOM  *
8030   REMark *  FIRST,COUNT NUMBER OF OBJECTS HERE  *
8040   REMark ****************************************
8050   TOTAL = (MAP(ROOM,5) > 0) + (MAP(ROOM,6) > 0) + (MAP(ROOM,7) > 0)
8060   DONE = 0
8070   PRINT #0,"You can see :";
8080   IF MAP(ROOM,5) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,5)); : DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
8090   IF MAP(ROOM,6) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,6)); : DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
8100   IF MAP(ROOM,7) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,7));
8110   PRINT #0,
8120   PAUSE RND(25 TO 50)
8130 END DEFine DESCRIBE_OBJECTS_IN_ROOM
8140 :
8150 DEFine PROCedure INITIALISE
8160   REMark **************************************************************
8170   REMark * INITIALISE THE ADVENTURE MAP - ROOMS, OBJECTS AND MONSTERS *
8180   REMark * HEAVILY COMMENTED AS THIS IS CENTRAL TO THE PROGRAM.       *
8190   REMark **************************************************************
8200   LOCal X,Y,RAN,CHOOSE_EMPTY,OB_NO,TOTAL,INSERT_AT
8210   :
8220   RESTORE
8230   :
8240   REMark ** TITLE$ is the name of the adventure, as printed to screen
8250   READ TITLE$
8260   :
8270   REMark ** CURRENCY$ is whether values are reported in Pounds, Dollars, Euros...
8280   READ CURRENCY$
8290   :
8300   REMark MAIN GAME ARRAYS:
8310   REMark   MAP() : ROOM PROPERTIES
8320   REMark   MAP(ROOM,1) - EXIT NORTH TO ROOM NUMBER (0=NO EXIT)
8330   REMark   MAP(ROOM,2) - EXIT SOUTH TO ROOM NUMBER (0=NO EXIT)
8340   REMark   MAP(ROOM,3) - EXIT EAST  TO ROOM NUMBER (0=NO EXIT)
8350   REMark   MAP(ROOM,4) - EXIT WEST  TO ROOM NUMBER (0=NO EXIT)
8360   REMark   MAP(ROOM,5) - OBJECT 1 IN THIS ROOM (0=NONE)
8370   REMark   MAP(ROOM,6) - OBJECT 2 IN THIS ROOM (0=NONE)
8380   REMark   MAP(ROOM,7) - OBJECT 3 IN THIS ROOM (0=NONE)
8390   REMark   MAP(ROOM,8) - MONSTER TYPE IN THIS ROOM (0=NONE)
8400   REMark
8410   REMark   CARRIED()   - ITEMS PICKED UP IF NON-ZERO
8420   REMark
8430   REMark   OBJECT$()   - OBJECT/TREASURE NAME
8440   REMark   VALUE()     - OBJECT/TREASURE VALUE
8450   REMark   WEAPON()    - 1=THIS IS A WEAPON, 0=NOT A WEAPON
8460   REMark
8470   REMark   MONSTER$()  - NAMES OF MONSTERS
8480   REMark
8490   REMark   WEAPONS()   - WEAPONS CARRIED
8500   REMark
8510   READ NO_OF_ROOMS    : REMark ** 1-n  (n=EXIT ROOM)
8520   READ ROOM           : REMark ** START IN THIS ROOM NUMBER
8530   READ NO_OF_OBJECTS  : REMark ** HOW MANY OBJECTS IN TOTAL
8540   READ NO_OF_MONSTERS : REMark ** TOTAL NUMBER OF MONSTERS
8550   :
8560   REMark ** ARRAYS USED TO HOLD DETAILS OF MAP, MONSTERS, OBJECTS ETC
8570   DIM MAP(NO_OF_ROOMS,8)          : REMark MAP OF ROOM EXITS
8580   DIM CARRIED(5)                  : REMark OBJECTS PICKED UP BY PLAYER
8590   DIM OBJECT$(NO_OF_OBJECTS,20)   : REMark OBJECT/TREASURE NAME
8600   DIM VALUE(NO_OF_OBJECTS)        : REMark OBJECT/TREASURE VALUE
8610   DIM WEAPON(NO_OF_OBJECTS)       : REMark 1=A WEAPON, 0=NOT A WEAPON
8620   DIM MONSTER$(NO_OF_MONSTERS,20) : REMark MONSTER NAME
8630   DIM WEAPONS(5)                  : REMark WEAPONS CARRIED
8640   DIM DIRECTION$(4,10)            : REMark DIRECTION NAMES
8650   DIRECTION$(1) = 'Northward' : DIRECTION$(2) = 'Southward'
8660   DIRECTION$(3) = 'Eastward'  : DIRECTION$(4) = 'Westward'
8670   :
8680   REMark ** NEXT LINES DECIDE HUMAN ATTRIBUTES
8690   H_STRE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark STRENGTH
8700   H_CHAR = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark CHARISMA
8710   H_DEXT = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark DEXTERITY
8720   H_INTE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark INTELLIGENCE
8730   H_WISD = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark WISDOM
8740   H_CONS = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark CONSTITUTION
8750   :
8760   CASH            = 0  : REMark ** TREASURE
8770   QUIT_FLAG       = 1  : REMark ** END OF GAME FLAG (1=SUCCESS, 2=EXHAUSTION, 4=QUIT COMMAND)
8780   MONSTERS_KILLED = 0  : REMark ** MONSTERS KILLED
8790   WORD1$          = "" : REMark ** FIRST WORD OF 2-WORD USER ENTRIES
8800   WORD2$          = "" : REMark ** SECOND WORD OF 2-WORD USER ENTRIES
8810   :
8820   REMark ** SET UP ROOMS
8830   FOR X = 1 TO NO_OF_ROOMS
8840     FOR Y = 1 TO 4 : READ MAP(X,Y)
8850   END FOR X
8860   :
8870   REMark ** DISTRIBUTE TREASURE, BUT IF A KEY IS REQUIRED
8880   REMark ** PLACE IT FIRST, BEFORE ANY LOCKED DOOR IN THE
8890   REMark ** OBJECTS HELD IN ROOMS  MAP(N,5) TO MAP(N,7)
8900   REMark ** NEGATIVE OBJECT NUMBERS MAKE OBJECT INVISIBLE
8910   REMark ** (SO THAT ANOTHER ACTION NEEDED TO MAKE VISIBLE)
8920   REMark ** GET LIST OF OBJECT NAMES AND OBJECT VALUES
8930   FOR X = 1 TO NO_OF_OBJECTS : READ OBJECT$(X),VALUE(X),WEAPON(X)
8940   :
8950   REMark ** PLACE KEY (OBJECT #1) IN SPECIFIED LOCATION
8960   REMark ** IF NOT USING LOCKED DOORS, OR NO KEY AT ALL
8970   REMark ** CHANGE LOOP TO for ob_no=1 to 8
8980   REMark ** REMEMBER KEY MUST BE *BEFORE* ANY LOCKED EXITS
8990   MAP(14,5) = 1 : REMark ** KEY STARTS OFF IN ROOM 14
9000   TOTAL = 1 : REMark ** HOW MANY OBJECTS PLACED SO FAR
9010   INSERT_AT = 5 : REMark ** TRY TO USE LOWER LOCATIONS IN ROOM
9020   FOR OB_NO = 2 TO NO_OF_OBJECTS
9030     REPeat CHOOSE_EMPTY
9040       RAN = RND(1 TO NO_OF_ROOMS-1) : REMark ** RANDOM ROOM NUMBER
9050       IF MAP(RAN,INSERT_AT) = 0 : EXIT CHOOSE_EMPTY : REMark ** FIRST OBJECT LOCATION (ONLY) IN ROOM
9060     END REPeat CHOOSE_EMPTY
9070     MAP(RAN,INSERT_AT) = OB_NO : REMark ** PLACE OBJECT NO. IN ROOM
9080     TOTAL = TOTAL + 1
9090     INSERT_AT = 5+(TOTAL DIV (NO_OF_ROOMS-1))
9100     IF INSERT_AT > 7 THEN EXIT OB_NO : REMark all locations full
9110   END FOR OB_NO
9120   PRINT
9130   :
9140   REMark ** DISTRIBUTE MONSTERS AMONG ROOMS AT RANDOM
9150   REMark ** MONSTERS HELD IN ROOMS  MAP(N,8)
9160   FOR COUNTER = 1 TO NO_OF_MONSTERS
9170     READ MONSTER$(COUNTER)
9180     REPeat CHOOSE_EMPTY
9190       RAN = RND(1 TO NO_OF_ROOMS) : REMark RANDOM ROOM NUMBER
9200       IF MAP(RAN,8) = 0 THEN EXIT CHOOSE_EMPTY
9210     END REPeat CHOOSE_EMPTY
9220     MAP(RAN,8) = COUNTER
9230   END FOR COUNTER
9240 END DEFine INITIALISE
9250 :
9260 REMark ********************************************************
9270 REMark * GAME DATA FOLLOWS - TITLE, LIST OF ROOM CONNECTIONS, *
9280 REMark * STARTING ROOM NUMBER, OBJECT DATA, MONSTERS LIST     *
9290 REMark ********************************************************
9300 REMark
9310 REMark ************************************
9320 REMark *   TITLE OF THE ADVENTURE GAME    *
9330 REMark ************************************
9340 DATA "ADVENTURE SHELL"
9350 :
9360 REMark ************************************
9370 REMark * Currency Unit `, $, Euro etc     *
9380 REMark ************************************
9390 DATA "`"
9400 :
9410 REMark ************************************
9420 REMark * ROOM DATA, FIRST VALUE IS NUMBER *
9430 REMark * NUMBER OF ROOMS, FOLLOWED BY THE *
9440 REMark * START ROOM NUMBER, FOLLOWED BY A *
9450 REMark * LIST OF EXITS  N,S,E,W FROM EACH *
9460 REMark * ROOM (0=NO EXIT,<>0 = LEADS TO A *
9470 REMark * ROOM NUMBER ( <0 = LOCKED DOOR). *
9480 REMark * A FINAL EXIT IS THE HIGHEST ROOM *
9490 REMark * NUMBER.                          *
9500 REMark * IF AN EXIT HAS A NEGATIVE VALUE, *
9510 REMark * IT'S A LOCKED DOOR, AND A KEY IS *
9520 REMark * NEEDED TO UNLOCK IT -  MAKE SURE *
9530 REMark * THAT THE KEY IS IN A ROOM BEFORE *
9540 REMark * A LOCKED DOOR, OR IT WILL NOT BE *
9550 REMark * POSSIBLE TO FIND THE KEY ! ALSO, *
9560 REMark * REMEMBER THAT LOCKED DOORS NEED  *
9570 REMark * -VE NUMBERS FROM BOTH SIDES !    *
9580 REMark * AS SUPPLIED, THE DOOR BETWEEN    *
9590 REMark * ROOMS 3 AND 16 IS LOCKED,AND THE *
9600 REMark * GAME STARTS FROM ROOM 9, ENDS AT *
9610 REMark * HIGHEST ROOM NUMBER.             *
9620 REMark ************************************
9630 DATA 16 : REMark ** NUMBER OF ROOMS
9640 DATA 9  : REMark ** START ROOM NUMBER
9650 DATA 8  : REMark ** NUMBER OF OBJECTS
9660 DATA 8  : REMark ** NUMBER OF MONSTERS
9670 REMark ************************************
9680 REMark * MAP OF ROOMS, TO HELP UNDERSTAND *
9690 REMark * THE MAPPING SYSTEM.  GAME STARTS *
9700 REMark * ROOM 9,ENDS ROOM 16, LOCKED DOOR *
9710 REMark * BETWEEN ROOMS 3 AND 16,  THE KEY *
9720 REMark * IN ROOM 14                       *
9730 REMark *                                  *
9740 REMark *                    16 <-EXIT     *
9750 REMark *                    | <-LOCKED    *
9760 REMark *          01   02 - 03            *
9770 REMark *          |    |                  *
9780 REMark *          04 - 05 - 06            *
9790 REMark *          |                       *
9800 REMark *          08   09 - 10   07       *
9810 REMark *          |    |         |        *
9820 REMark *          11 - 12 ------ 13       *
9830 REMark *          |                       *
9840 REMark *    key-> 14 - 15                 *
9850 REMark *                                  *
9860 REMark ************************************
9870 DATA 0,4,0,0   : REMark ** ROOM 1
9880 DATA 0,5,3,0   : REMark ** ROOM 2
9890 DATA -16,0,0,2 : REMark ** ROOM 3
9900 DATA 1,8,5,0   : REMark ** ROOM 4
9910 DATA 2,0,6,4   : REMark ** ROOM 5
9920 DATA 0,0,0,5   : REMark ** ROOM 6
9930 DATA 0,13,0,0  : REMark ** ROOM 7
9940 DATA 4,11,0,0  : REMark ** ROOM 8
9950 DATA 0,12,10,0 : REMark ** ROOM 9
9960 DATA 0,0,0,9   : REMark ** ROOM 10
9970 DATA 8,14,12,0 : REMark ** ROOM 11
9980 DATA 9,0,13,11 : REMark ** ROOM 12
9990 DATA 7,0,0,12  : REMark ** ROOM 13
10000 DATA 11,0,15,0 : REMark ** ROOM 14
10010 DATA 0,0,0,14  : REMark ** ROOM 15
10020 DATA 0,-3,0,0  : REMark ** ROOM 16 (LAST ROOM=EXIT FROM MAZE)
10030 :
10040 REMark ************************************
10050 REMark * OBJECTS DATA : NAME,VALUE,WEAPON *
10060 REMark ************************************
10070 DATA "Key",2,0
10080 DATA "Sword",0,1
10090 DATA "Axe",0,1
10100 DATA "Ring",567,0
10110 DATA "Locket",15,0
10120 DATA "Elven-Gold",799,0
10130 DATA "Amythest",27,0
10140 DATA "Crystal",45,0
10150 :
10160 REMark ************************************
10170 REMark * MONSTER NAMES                    *
10180 REMark ************************************
10190 DATA "Entangler"
10200 DATA "Artifactum"
10210 DATA "inkblott"
10220 DATA "Ugly Undead"
10230 DATA "'orrible Orc"
10240 DATA "Ice-Dragon"
10250 DATA "Embihuund"
10260 DATA "Insalivate"
10270 :
10280 REMark ***************************************************************
10290 REMark * STRING HANDLING FUNCTIONS FOR EASIER CONVERSION TO QL BASIC *
10300 REMark ***************************************************************
10310 :
10320 DEFine FuNction STR$(NUM)
10330   REMark CONVERT NUMERIC VALUE TO STRING
10340   LOCal T$
10350   T$ = NUM
10360   RETurn T$
10370 END DEFine STR$
10380 :
10390 DEFine FuNction LEFT$(S$,NUM)
10400   REMark RETURN 'NUM' CHARACTERS FROM START OF STRING
10410   IF NUM < 1 THEN RETurn ""
10420   IF NUM > LEN(S$) THEN RETurn S$
10430   RETurn S$(1 TO NUM)
10440 END DEFine LEFT$
10450 :
10460 DEFine FuNction MID$(S$,START,NUM)
10470   REMark RETURN 'NUM' CHARACTERS FROM SPECIFIED START POINT IN STRING
10480   IF START < 1 OR START > LEN(S$) THEN RETurn ""
10490   IF NUM < 1 THEN RETurn ""
10500   RETurn S$(START TO START+NUM-1)
10510 END DEFine MID$
10520 :
10530 DEFine FuNction TL$(S$)
10540   LOCal T$,N
10550   REMark STRIP SPACES FROM LEFT OF STRING
10560   T$ = ""
10570   FOR N = 1 TO LEN(S$)
10580     IF S$(N) <> " " THEN T$ = S$(N TO LEN(S$)) : EXIT N
10590   END FOR N
10600   RETurn T$
10610 END DEFine TL$
